import processing.core.*; 
import processing.xml.*; 

import gifAnimation.*; 
import ddf.minim.*; 
import ddf.minim.signals.*; 
import ddf.minim.analysis.*; 
import ddf.minim.effects.*; 
import processing.opengl.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class sost extends PApplet {









PImage ghostpic;
PImage runner;
Manager ghosts;
Player player;
boolean[] keys = new boolean[526];
float bars;
int score = 0;
PFont font;

Minim minim;
AudioSample ding;
AudioSample buzz;

Gif ghosty;
Gif runny;

public void setup() {
  size(1000, 600, OPENGL);
  player = new Player();
  ghosts = new Manager();
  for (int i=0;i<5;i++) {
    ghosts.add( new Ghost() );
  }
  runner = loadImage("runner.gif");
  ghostpic = loadImage("ghost.gif");
  
  font = loadFont("myfont.vlw");
  textFont(font);
  
  ghosty = new Gif(this,"ghost.gif");
  ghosty.play();
  
  runny = new Gif(this,"runner.gif");
  runny.play();
  
  bars = 90;
  minim = new Minim(this);
  ding = minim.loadSample("thanks.wav");
  buzz = minim.loadSample("buzz.wav");
  
}

public void draw() {
  fill(255,0,0,30);
   rect(0,0,width,bars); 
   
   if(ghosts.size()<5){
    ghosts.add( new Ghost() ); 
   }
  
  
    fill(0,0,255,40);
   rect(0,height,width,-bars); 
  
  fill(0, 40);
  rect(0, 0, width, height);
  
  player.go();

  ghosts.go();
  ghosts.display();
  
  player.display();
  
  ghosts.clean();
  
  fill(255);
  textSize(44);
  text(score+" SOSTS have been sorted",10,40);
  
  textSize(20);
  text("WASD and K",10,height-30);
}




public boolean checkKey(String k)
{
  for(int i = 0; i < keys.length; i++)
    if(KeyEvent.getKeyText(i).toLowerCase().equals(k.toLowerCase())) return keys[i];  
  return false;
}
 
public void keyPressed()
{ 
  keys[keyCode] = true;
  println(KeyEvent.getKeyText(keyCode));
}
 
public void keyReleased()
{ 
  keys[keyCode] = false; 
}


public float towards(PVector b, PVector a){
 return atan2((a.y-b.y), (a.x-b.x));
 
  
}
class Base {
  boolean remove;
  PVector pos;
  PVector mov;

  Base() {
    pos = new PVector();
    mov = new PVector();
  }

  public void go() {
  }

  public void display() {
  }
  
  public boolean touch(Base thing, float distance){
   if(distance > sqrt(sq(thing.pos.x-pos.x)+sq(thing.pos.y-pos.y))){
    return true;
   } else {
    return false; 
   }
  }
  
}
class Ghost extends Base {
  float angle;
  boolean pulled;
  boolean isTop;


  Ghost() {
    
    super();
    pos.x = round(random(1))*width;
    pos.y = height/4.0f+random(height/2.0f);
    mov.x = random(1)-0.5f;
    mov.y = random(1)-0.5f;
    mov.mult(4);
    if(random(1)>0.5f){
     isTop = true; 
    }
  }

  public void go() {
     if(pos.y < bars){
      mov.y += 0.07f;
     } 

     if(pos.y > height-bars){
      mov.y -= 0.07f;
     } 
    
    pos.add(mov);
    angle += 0.03f*(random(1)-0.5f);

    pos.x = (pos.x+width)%width;
     if(isTop){
      if(pos.y<0){
       remove = true;
       score += 1;
       
       ding.trigger();
      } 
     } else {
      if(pos.y>height){
       remove = true;
       score += 1;
       ding.trigger();
      } 
     }

    mov.limit(7);
    
    if(mov.mag()>3.5f){
     mov.mult(0.99f); 
    }
    
  }

  public void display() {

    pushMatrix();

    translate(pos.x, pos.y);
    rotate(angle);
    if (pulled) {
      tint(random(255), random(255), random(255));
    } 
    else {
      if(isTop){
       tint(255,100,100); 
      } else {
       tint(100,100,255); 
      }
    }
    image(ghosty, -ghostpic.width/2.0f, -ghostpic.height/2.0f);
    popMatrix();
  }
}

class Manager extends ArrayList {

  Manager() {
    super();
  }

  //do the go routines
  public void go() {
    int which = PApplet.parseInt(random(this.size()));
     Base slide = (Base) this.get(which);
     this.remove(which);
     this.add(slide);
     
    for (int i=0;i<this.size();i++) {
      Base item = (Base) this.get(i);
      item.go();
    }
    
  }

  //display em all
  public void display() {
    for (int i=0;i<this.size();i++) {
      Base item = (Base) this.get(i);
      item.display();
    }
  }

  //remove dead guys in reverse order
  public void clean() {
    for (int i=this.size()-1;i>-1;i--) {
      Base item = (Base) this.get(i);
      if (item.remove) {
        this.remove(i);
      }
    }
  }
}

class Player extends Base {

  Ghost pulling;
  float speed = 0.4f;
  float zone = 100;

  Player() {
    super();
  } 

  public void go() {
    if (checkKey("A")) {
      mov.x -= speed;
    } 
    if (checkKey("D")) {
      mov.x += speed;
    } 
    if (checkKey("W")) {
      mov.y -= speed;
    } 
    if (checkKey("S")) {
      mov.y += speed;
    } 
    
    if(pos.y < bars){
      mov.y += 0.7f;
     } 

     if(pos.y > height-bars){
      mov.y -= 0.7f;
     } 

    pos.add(mov);

    pos.x = (pos.x+width)%width;
    pos.y = (pos.y+height)%height;

    if (pulling == null && checkKey("K")) {
      for (int i=0;i<ghosts.size();i++) {
        Ghost friend = (Ghost) ghosts.get(i);
        if (friend.touch(this, zone)) {
          pulling = friend;
          pulling.pulled = true;
          break;
        }
      }
    } 
    else if (pulling != null) {
      buzz.trigger();
      stroke(random(255));
      line(this.pos.x, this.pos.y, pulling.pos.x, pulling.pos.y);
      float towards = towards(pulling.pos, this.pos);

      pulling.mov.add(new PVector(cos(towards)*0.4f, sin(towards)*0.4f) );
      if (!checkKey("K")) {
        pulling.pulled = false;
        pulling = null;
      }
    }

    print(frameRate+"   \n");
    mov.limit(7);
  }

  public void display() {
    noStroke();
    fill(0,50,30,50);
    ellipse(pos.x,pos.y,zone*2,zone*2);
    image(runny, pos.x-runner.width/2.0f, pos.y-runner.height/2.0f);
  }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "sost" });
  }
}
