import gifAnimation.*;

import ddf.minim.*;
import ddf.minim.signals.*;
import ddf.minim.analysis.*;
import ddf.minim.effects.*;

import processing.opengl.*;
PImage ghostpic;
PImage runner;
Manager ghosts;
Player player;
boolean[] keys = new boolean[526];
float bars;
int score = 0;
PFont font;

Minim minim;
AudioSample ding;
AudioSample buzz;

Gif ghosty;
Gif runny;

void setup() {
  size(1000, 600, OPENGL);
  player = new Player();
  ghosts = new Manager();
  for (int i=0;i<5;i++) {
    ghosts.add( new Ghost() );
  }
  runner = loadImage("runner.gif");
  ghostpic = loadImage("ghost.gif");
  
  font = loadFont("myfont.vlw");
  textFont(font);
  
  ghosty = new Gif(this,"ghost.gif");
  ghosty.play();
  
  runny = new Gif(this,"runner.gif");
  runny.play();
  
  bars = 90;
  minim = new Minim(this);
  ding = minim.loadSample("thanks.wav");
  buzz = minim.loadSample("buzz.wav");
  
}

void draw() {
  fill(255,0,0,30);
   rect(0,0,width,bars); 
   
   if(ghosts.size()<5){
    ghosts.add( new Ghost() ); 
   }
  
  
    fill(0,0,255,40);
   rect(0,height,width,-bars); 
  
  fill(0, 40);
  rect(0, 0, width, height);
  
  player.go();

  ghosts.go();
  ghosts.display();
  
  player.display();
  
  ghosts.clean();
  
  fill(255);
  textSize(44);
  text(score+" SOSTS have been sorted",10,40);
  
  textSize(20);
  text("WASD and K",10,height-30);
}




boolean checkKey(String k)
{
  for(int i = 0; i < keys.length; i++)
    if(KeyEvent.getKeyText(i).toLowerCase().equals(k.toLowerCase())) return keys[i];  
  return false;
}
 
void keyPressed()
{ 
  keys[keyCode] = true;
  println(KeyEvent.getKeyText(keyCode));
}
 
void keyReleased()
{ 
  keys[keyCode] = false; 
}


float towards(PVector b, PVector a){
 return atan2((a.y-b.y), (a.x-b.x));
 
  
}
